> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.itential.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.itential.com/_mcp/server.

# Find a form

GET https://example.itential.io/json-forms/forms/{id}

Finds a previously created JSON form, based on a supplied document ID.

Reference: https://docs.itential.com/itential-cloud/api-reference/json-forms/get-form-by-id

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Request

### Path parameters

- `id` (string, required) — Unique name of the form

## Response

### 200

document of requested form

- `created` (string, required)
- `createdBy` (string, required)
- `lastUpdated` (string, required)
- `lastUpdatedBy` (string, required)
- `name` (string, required)
- `description` (string, required, nullable)
- `struct` (object, required)
  - `type` (string, required)
  - `items` (list of object or object or object or object or object or object or object, required)
    - object
      - `nodeId` (string, required)
      - `type` (string, required)
      - `title` (string, required)
      - `items` (list of any or object or object or object or object or object or object, required)
        - object
          - `nodeId` (string, required)
          - `type` ("boolean", required)
          - `title` (string, required)
          - `description` (string, required)
          - `customKey` (string or boolean, optional)
          - `required` (boolean, optional)
          - `options` (object, optional)
          - `helper` (string, optional)
          - `default` (boolean, optional)
          - `enum` (list of object, optional)
            - `id` (string, optional)
            - `value` (boolean, optional)
          - `readOnly` (boolean, optional)
          - `widget` (string, optional)
        - object
          - `nodeId` (string, required)
          - `type` ("number", required)
          - `title` (string, required)
          - `description` (string, required)
          - `placeholder` (string, required)
          - `required` (boolean, required)
          - `customKey` (string or boolean, optional)
          - `widget` (string, optional)
          - `options` (object, optional)
          - `helper` (string, optional)
          - `validation` (map from string to any or list of any, optional)
          - `readOnly` (boolean, optional)
          - `minimum` (double, optional, nullable)
          - `maximum` (double, optional, nullable)
          - `default` (double, optional, nullable)
          - `disabled` (boolean, optional)
        - object
          - `nodeId` (string, required)
          - `type` ("string", required)
          - `title` (string, required)
          - `description` (string, required)
          - `placeholder` (string, required)
          - `required` (boolean, required)
          - `customKey` (string or boolean, optional)
          - `options` (object, optional)
          - `helper` (string, optional)
          - `pattern` (string, optional)
          - `validation` (map from string to any or list of any, optional)
          - `readOnly` (boolean, optional)
          - `binding` (boolean, optional)
          - `rel` (string, optional)
          - `targetPointer` (string, optional)
          - `format` (string, optional)
          - `minLength` (integer, optional)
          - `maxLength` (integer, optional)
          - `default` (string, optional)
          - `disabled` (boolean, optional)
        - object
          - `nodeId` (string, required)
          - `type` ("string", required)
          - `title` (string, required)
          - `description` (string, required)
          - `placeholder` (string, required)
          - `required` (boolean, required)
          - `customKey` (string or boolean, optional)
          - `widget` (string, optional)
          - `options` (object, optional)
          - `helper` (string, optional)
          - `pattern` (string, optional)
          - `validation` (map from string to any or list of any, optional)
          - `readOnly` (boolean, optional)
          - `format` (string, optional)
          - `minLength` (integer, optional)
          - `maxLength` (integer, optional)
          - `default` (string, optional)
          - `disabled` (boolean, optional)
        - object
          - `nodeId` (string, required)
          - `type` (string, required)
          - `title` (string, required)
          - `description` (string, required)
          - `required` (boolean, required)
          - `customKey` (string or boolean, optional)
          - `options` (object, optional)
          - `helper` (string, optional)
          - `placeholder` (string, optional)
          - `enum` (list of string or map from string to any, optional, default: [])
          - `enumNames` (list of object, optional, default: [])
          - `binding` (boolean, optional, default: false)
          - `pattern` (string, optional)
          - `rel` (string, optional)
          - `targetPointer` (string, optional)
          - `method` (string, optional, nullable)
          - `body` (object, optional)
          - `sourcePointer` (string, optional, nullable)
          - `sourceKeyPointer` (string, optional, nullable)
          - `labelKeyPointer` (string, optional, nullable)
          - `base` (string, optional, nullable)
          - `href` (string, optional, nullable)
          - `validation` (map from string to any or list of any, optional)
          - `readOnly` (boolean, optional)
          - `transformation` (string or map from string to any, optional, nullable)
          - `disabled` (boolean, optional)
          - `default` (string or list of string, optional)
          - `widget` (string, optional)
          - `radio` (boolean, optional)
          - `inline` (boolean, optional)
        - object
          - `nodeId` (string, required)
          - `type` ("string", required)
          - `title` (string, required)
          - `description` (string, required)
          - `helper` (string, optional)
          - `required` (boolean, optional)
          - `format` ("data-url", optional)
          - `customKey` (string or boolean, optional)
      - `required` (boolean or list of any, optional)
      - `options` (object, optional)
      - `description` (string, optional)
      - `helper` (string, optional)
      - `collapsed` (boolean, optional)
      - `readOnly` (boolean, optional)
      - `schemaOption` (boolean, optional)
      - `combinationType` (string, optional)
      - `widget` (string, optional)
      - `uniqueItems` (boolean, optional)
      - `minItems` (double, optional)
      - `maxItems` (double, optional)
      - `customKey` (string or boolean, optional)
    - object
      - `nodeId` (string, required)
      - `type` ("boolean", required)
      - `title` (string, required)
      - `description` (string, required)
      - `customKey` (string or boolean, optional)
      - `required` (boolean, optional)
      - `options` (object, optional)
      - `helper` (string, optional)
      - `default` (boolean, optional)
      - `enum` (list of object, optional)
        - `id` (string, optional)
        - `value` (boolean, optional)
      - `readOnly` (boolean, optional)
      - `widget` (string, optional)
    - object
      - `nodeId` (string, required)
      - `type` ("number", required)
      - `title` (string, required)
      - `description` (string, required)
      - `placeholder` (string, required)
      - `required` (boolean, required)
      - `customKey` (string or boolean, optional)
      - `widget` (string, optional)
      - `options` (object, optional)
      - `helper` (string, optional)
      - `validation` (map from string to any or list of any, optional)
      - `readOnly` (boolean, optional)
      - `minimum` (double, optional, nullable)
      - `maximum` (double, optional, nullable)
      - `default` (double, optional, nullable)
      - `disabled` (boolean, optional)
    - object
      - `nodeId` (string, required)
      - `type` ("string", required)
      - `title` (string, required)
      - `description` (string, required)
      - `placeholder` (string, required)
      - `required` (boolean, required)
      - `customKey` (string or boolean, optional)
      - `options` (object, optional)
      - `helper` (string, optional)
      - `pattern` (string, optional)
      - `validation` (map from string to any or list of any, optional)
      - `readOnly` (boolean, optional)
      - `binding` (boolean, optional)
      - `rel` (string, optional)
      - `targetPointer` (string, optional)
      - `format` (string, optional)
      - `minLength` (integer, optional)
      - `maxLength` (integer, optional)
      - `default` (string, optional)
      - `disabled` (boolean, optional)
    - object
      - `nodeId` (string, required)
      - `type` ("string", required)
      - `title` (string, required)
      - `description` (string, required)
      - `placeholder` (string, required)
      - `required` (boolean, required)
      - `customKey` (string or boolean, optional)
      - `widget` (string, optional)
      - `options` (object, optional)
      - `helper` (string, optional)
      - `pattern` (string, optional)
      - `validation` (map from string to any or list of any, optional)
      - `readOnly` (boolean, optional)
      - `format` (string, optional)
      - `minLength` (integer, optional)
      - `maxLength` (integer, optional)
      - `default` (string, optional)
      - `disabled` (boolean, optional)
    - object
      - `nodeId` (string, required)
      - `type` (string, required)
      - `title` (string, required)
      - `description` (string, required)
      - `required` (boolean, required)
      - `customKey` (string or boolean, optional)
      - `options` (object, optional)
      - `helper` (string, optional)
      - `placeholder` (string, optional)
      - `enum` (list of string or map from string to any, optional, default: [])
      - `enumNames` (list of object, optional, default: [])
      - `binding` (boolean, optional, default: false)
      - `pattern` (string, optional)
      - `rel` (string, optional)
      - `targetPointer` (string, optional)
      - `method` (string, optional, nullable)
      - `body` (object, optional)
      - `sourcePointer` (string, optional, nullable)
      - `sourceKeyPointer` (string, optional, nullable)
      - `labelKeyPointer` (string, optional, nullable)
      - `base` (string, optional, nullable)
      - `href` (string, optional, nullable)
      - `validation` (map from string to any or list of any, optional)
      - `readOnly` (boolean, optional)
      - `transformation` (string or map from string to any, optional, nullable)
      - `disabled` (boolean, optional)
      - `default` (string or list of string, optional)
      - `widget` (string, optional)
      - `radio` (boolean, optional)
      - `inline` (boolean, optional)
    - object
      - `nodeId` (string, required)
      - `type` ("string", required)
      - `title` (string, required)
      - `description` (string, required)
      - `helper` (string, optional)
      - `required` (boolean, optional)
      - `format` ("data-url", optional)
      - `customKey` (string or boolean, optional)
  - `nodeId` (string, optional)
  - `projectId` (string, optional)
- `schema` (object, required)
  - `type` (string, required)
  - `title` (string, required)
  - `_id` (string, optional)
  - `uniqueItems` (boolean, optional)
  - `minItems` (double, optional)
  - `maxItems` (double, optional)
  - `description` (string, optional)
  - `required` (list of string, optional)
  - `readOnly` (boolean, optional)
  - `options` (object, optional)
  - `properties` (object, optional)
  - `items` (object, optional)
  - `anyOf` (list of object, optional)
  - `oneOf` (list of object, optional)
  - `allOf` (list of object, optional)
- `uiSchema` (object, required)
- `validationSchema` (object, required)
- `bindingSchema` (object, required)
- `version` (string, required)
- `_id` (string, optional)
- `tags` (list of string or map from string to any, optional)
- `id` (string, optional)
- `namespace` (object, optional, nullable)
  - `type` (any, optional)
  - `_id` (string, optional)
  - `name` (string, optional)
  - `accessControl` (object, optional)
    - `read` (list of string, optional)
    - `execute` (list of string, optional)
    - `write` (list of string, optional)
    - `manage` (list of string, optional)

## Errors

### 500 Internal Server Error

Error response from API

- `any`

## Examples

**Response**

```json
{
  "created": "2019-04-16T00:43:22.038Z",
  "createdBy": "5cb08d4f16640f00182c3890",
  "lastUpdated": "2019-04-16T00:43:22.038Z",
  "lastUpdatedBy": "5cb08d4f16640f00182c3890",
  "name": "Device Form",
  "description": "This form describes the connection information for a device.",
  "struct": {
    "type": "string",
    "items": [
      {
        "collapsed": true,
        "combinationType": "string",
        "customKey": "string",
        "description": "This section describes the connection information for a device.",
        "helper": "Tooltip help message goes here",
        "items": [
          null
        ],
        "maxItems": 1.1,
        "minItems": 1.1,
        "nodeId": "kdWO-g4oS3GkzrbqDqCZUw",
        "options": {},
        "readOnly": true,
        "required": true,
        "schemaOption": true,
        "title": "Connection Information",
        "type": "string",
        "uniqueItems": true,
        "widget": "string"
      }
    ],
    "nodeId": "kdWO-g4oS3GkzrbqDqCZUw",
    "projectId": "string"
  },
  "schema": {
    "type": "string",
    "title": "Connection Information",
    "_id": "string",
    "uniqueItems": true,
    "minItems": 1.1,
    "maxItems": 1.1,
    "description": "This form describes the connection information for a device.",
    "required": [
      "kdWO-g4oS3GkzrbqDqCZUw"
    ],
    "readOnly": true,
    "options": {},
    "properties": {},
    "items": {
      "_id": "string",
      "properties": {},
      "readOnly": true,
      "required": [
        "string"
      ],
      "type": "string"
    },
    "anyOf": [
      {}
    ],
    "oneOf": [
      {}
    ],
    "allOf": [
      {}
    ]
  },
  "uiSchema": {},
  "validationSchema": {},
  "bindingSchema": {},
  "version": "2020.1",
  "_id": "5cb5252a1bbc5a00def564c1",
  "tags": [
    "5cb5252a1bbc5a00def564c1"
  ],
  "id": "5cb5252a1bbc5a00def564c1",
  "namespace": null
}
```

**SDK Code**

```python
import requests

url = "https://example.itential.io/json-forms/forms/id"

response = requests.get(url)

print(response.json())
```

```javascript
const url = 'https://example.itential.io/json-forms/forms/id';
const options = {method: 'GET'};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://example.itential.io/json-forms/forms/id"

	req, _ := http.NewRequest("GET", url, nil)

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://example.itential.io/json-forms/forms/id")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://example.itential.io/json-forms/forms/id")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://example.itential.io/json-forms/forms/id');

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://example.itential.io/json-forms/forms/id");
var request = new RestRequest(Method.GET);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let request = NSMutableURLRequest(url: NSURL(string: "https://example.itential.io/json-forms/forms/id")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```